Index: arch/ia32/src/smp/apic.c
===================================================================
--- arch/ia32/src/smp/apic.c	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ arch/ia32/src/smp/apic.c	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -44,5 +44,5 @@
  * Tested on:
  *	Bochs 2.0.2 - Bochs 2.2 with 2-8 CPUs
- *	Simics 2.0.28 - Simics 2.2.19 2-8 CPUs
+ *	Simics 2.0.28 - Simics 2.2.19 2-15 CPUs
  *	VMware Workstation 5.5 with 2 CPUs
  *	ASUS P/I-P65UP5 + ASUS C-P55T2D REV. 1.41 with 2x 200Mhz Pentium CPUs
Index: arch/ia64/src/drivers/keyboard.c
===================================================================
--- arch/ia64/src/drivers/keyboard.c	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ arch/ia64/src/drivers/keyboard.c	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -1,5 +1,3 @@
 /*
- * Copyright (C) 2003 Josef Cejka
- * Copyright (C) 2005 Jakub Jermar
  * Copyright (C) 2005 Jakub Vana
  * All rights reserved.
@@ -47,7 +45,5 @@
 };
 
-
-int kb_disable;
-
+bool kb_disable;
 
 /** Initialize keyboard subsystem. */
@@ -59,14 +55,17 @@
 }
 
-/** Process keyboard interrupt. */
+/** Ask keyboard if a key was pressed. */
 void poll_keyboard(void)
 {
-	if(kb_disable) return;
 	char ch;
 
+	if (kb_disable)
+		return;
+
 	ch = ski_getchar();
-	if(ch=='\r') ch='\n'; 
-	if(ch) chardev_push_character(&kbrd, ch);
-	
+	if(ch == '\r')
+		ch = '\n'; 
+	if (ch)
+		chardev_push_character(&kbrd, ch);
 }
 
@@ -74,5 +73,5 @@
 void keyboard_enable(void)
 {
-	kb_disable=false;
+	kb_disable = false;
 }
 
@@ -80,4 +79,4 @@
 void keyboard_disable(void)
 {
-	kb_disable=true;	
+	kb_disable = true;	
 }
Index: arch/ia64/src/ski/ski.c
===================================================================
--- arch/ia64/src/ski/ski.c	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ arch/ia64/src/ski/ski.c	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -66,11 +66,12 @@
 }
 
-
-/** Display character on debug console
+/** Ask debug console if a key was pressed.
  *
  * Use SSC (Simulator System Call) to
  * get character from debug console.
- * Non blocking HW call
- * @return Returns ascii code of pressed key or 0 if no key pressed
+ *
+ * This call is non-blocking.
+ *
+ * @return ASCII code of pressed key or 0 if no key pressed.
  */
 __s32 ski_getchar(void)
Index: doc/arch/ia32
===================================================================
--- doc/arch/ia32	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ doc/arch/ia32	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -20,5 +20,5 @@
                 o 2x-8x 686 CPU
         o Simics 2.0.28 - Simics 2.2.19
-                o 2x-8x Pentium 4 CPU
+                o 2x-15x Pentium 4 CPU
 	o VMware Workstation 5.5
 		o 2x CPU
Index: generic/src/main/kinit.c
===================================================================
--- generic/src/main/kinit.c	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ generic/src/main/kinit.c	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -58,6 +58,12 @@
 #endif /* CONFIG_TEST */
 
-
-
+/** Kernel initialization thread.
+ *
+ * kinit takes care of higher level kernel
+ * initialization (i.e. thread creation,
+ * userspace initialization etc.).
+ *
+ * @param arg Not used.
+ */
 void kinit(void *arg)
 {
Index: generic/src/main/main.c
===================================================================
--- generic/src/main/main.c	(revision 5803145469be60e6aa7cd5bb34d33051443a47e9)
+++ generic/src/main/main.c	(revision 880de6e610f43a65959164623f814d228462cdda)
@@ -77,6 +77,6 @@
 context_t ctx;
 
-/*
- * These 'hardcoded' variables will be intialised by
+/**
+ * These 'hardcoded' variables will be intialized by
  * the linker or the low level assembler code with
  * appropriate sizes and addresses.
@@ -89,10 +89,10 @@
 size_t init_size = 0;
 
-/*
+/**
  * Size of memory in bytes taken by kernel and heap.
  */
 static size_t kernel_size;
 
-/*
+/**
  * Size of heap.
  */
@@ -100,5 +100,5 @@
 
 
-/*
+/**
  * Extra space between heap and stack
  * enforced by alignment requirements.